#include "header.h"
#include <string.h>
//видалення наступного елементу після переданого
char delnext(struct book* delnext, unsigned int *total) {
    if (delnext->next) {
        struct book* delme=delnext->next;
        delnext->next=delme->next;
        free(delme);
        if(total)(*total)--;
        return 1;
    } else return 0;
}
//видалення переданого елементу. Використовувалося лише для видалення голови
void delfirst(struct book** delme,unsigned int *total) {
    struct book* realdelme=*delme;
    if ((*delme)->next) *delme=(*delme)->next;
    free(realdelme);
    if(total)(*total)--;
}
//видалення елементу з індексом n. Не використовуйте для голови.
char delindex(struct book* head, unsigned int n,unsigned int *total) {
    if (n<1) return 0;
    for (unsigned int i=1;i<n;i++)
        head=head->next;
    return delnext(head,total);
}
//вставка елементу insertme після after В процесі розробки була визнана зайвою.
// void insert(struct book* after, struct book* insertme, unsigned int *total){
//     if(after) {
//         insertme->next=after->next;
//         after->next=insertme;
//     } else exit(2);
// }

//повертає хвіст. Приймає будь-який елемент
struct book* gettail(struct book* start) {
    if (!start) return 0;
    while (start->next)start=start->next;
    return start;
}

//псевдооптимізоване сортування списку за будь-яким полем у будь-якому порядку.
//Точний принцип роботи невідомий. Не чіпайте це. Краще перепишіть, якщо лізете.
void selectstruct(struct book** pFirst,short offset, char sortbyfield){
    struct book* pfirstOp=*pFirst;
    //пропуск вже посортованих
    for (short a = 0; a < offset; a++)pfirstOp=pfirstOp->next;
    if (!pfirstOp||!pfirstOp->next)return;
    //вихід, якщо сортування неможливе за браком елементів.
    //Програма писалася так, щоб за таких умов дана функція навіть не викликалася
    struct book* min=pfirstOp;
    struct book* curp=pfirstOp->next;
    short minc=0;
    short mincreal=-1;
    while (curp) {
        char compara;
        switch(sortbyfield){
        case(0):
            compara=strcmp(min->author,curp->author)>0;break;
        case(1):
            compara=strcmp(min->name,curp->name)>0;break;
        case(2):
            compara=min->date>curp->date;break;
        case(3):
            compara=min->pages>curp->pages;break;
        case(4):
            compara=min->price>curp->price;break;
        case(5):
            compara=strcmp(min->author,curp->author)<0;break;
        case(6):
            compara=strcmp(min->name,curp->name)<0;break;
        case(7):
            compara=min->date<curp->date;break;
        case(8):
            compara=min->pages<curp->pages;break;
        case(9):
            compara=min->price<curp->price;break;
        }
        if (compara)
            min=curp;mincreal=minc;
        curp=curp->next;
        minc++;
    }
    struct book* temp=pfirstOp;
    struct book* rememba=min->next;
    if (!offset) {
        *pFirst=min;pfirstOp=*pFirst;
        pfirstOp->next=temp->next;
    } else {
        struct book* prev=*pFirst;
        while (prev->next!=pfirstOp)
            prev=prev->next;
        prev->next=min;
        min->next=temp->next;
        pfirstOp=min;
    }
    curp=pfirstOp;
    temp->next=rememba;
    if (mincreal!=-1){
        for (short a=0;a<mincreal;a++)
            curp=curp->next;
        curp->next=temp;
    }
    //displayevery(*pFirst);
    if(!temp->next)
        switch (sortbyfield) {
        case(0):
            if (strcmp(curp->author,temp->author)<=0)
                return;
            break;
        case(1):
            if (strcmp(curp->name,temp->name)<=0)
                return;
            break;
        case(2):
            if(curp->date<temp->date)
                return;
            break;
        case(3):
            if(curp->pages<temp->pages)
                return;
            break;
        case(4):
            if(curp->price<temp->price)
                return;
            break;
        case(5):
            if (strcmp(curp->author,temp->author)>=0)
                return;
            break;
        case(6):
            if (strcmp(curp->name,temp->name)>=0)
                return;
            break;
        case(7):
            if(curp->date>temp->date)
                return;
            break;
        case(8):
            if(curp->pages>temp->pages)
                return;
            break;
        case(9):
            if(curp->price>temp->price)
                return;
            break;
        }
    selectstruct(pFirst,offset+1,sortbyfield);
}
// //максимальне з двох за сторінками, black завджи ігнорується
// struct book* max2(struct book* pFirst,const struct book* black){
//     struct book* max=pFirst;
//     while (max==black) max=max->next;
//     struct book* cur=max->next;
//     while (cur==black) cur=cur->next;
//     while (cur) {
//         if (cur->pages>max->pages&&cur!=black)max=cur;
//         cur=cur->next;
//     }
//     return max;
// }
//відображає кожний елемент списку. Приймає голову
void displayevery(const struct book* displayus) {
    unsigned int i=1;
    displaystart;
    while (displayus) {
        printf("%-8d",i);
        displayone(displayus);
        displayus=displayus->next;
        i++;
    }
}
//виводить кожний елемент списку в файл. У простому вигляді
void writeevery(const struct book* displayus, FILE* out) {
    while (displayus) {
        fprintf(out,"%s %s %hd %hu %hd\n",
                displayus->author,displayus->name,
                displayus->date,displayus->pages,displayus->price);
        displayus=displayus->next;
    }
    fclose(out);
}
struct book* readF(FILE* inputF,unsigned int* total) {
    struct book *head=malloc(sizeof (struct book));
    *total=0;
    fseek(inputF, 0, SEEK_SET);
    struct book *curp=NULL;
    while(1) {
        if (!curp) {//якщо це перший елемегт - оперуємо з ним.
            fscanf(inputF,"%s",head->author);
            curp=head;
        }
        else {
            curp->next=malloc(sizeof (struct book));
            //якщо ж перший елемент вже є - створюємо новий
            if (fscanf(inputF,"%s",curp->next->author)!=1) {
                free(curp->next);
                curp->next=NULL;
                break;
                //якщо зчитати не вдалося, то, мабуть, ввід закінчений.
                //Відміняємо запис останнього елементу, закінчуємо запис загалом
            }
            curp=curp->next;
        }
        while (curp->author[strlen(curp->author)-1]!=',') {
            unsigned short pos=strlen(curp->author);
            //до моменту, коли , - більше не останній символ
            //обробка для правильного зчитування fscanf. За потреби - розділення імені та прізвища
            checkeof(inputF);
            curp->author[pos]=' ';
            fscanf(inputF,"%s",&(curp->author[pos+1]));
        }
        curp->author[strlen(curp->author)-1]=0;//кінець вводу
        fscanf(inputF,"%s",curp->name);
        while (curp->name[strlen(curp->name)-1]!=',') {
            unsigned short pos=strlen(curp->name);
            //ідентичне вводу атвора
            checkeof(inputF);
            curp->name[pos]=' ';
            fscanf(inputF,"%s",&(curp->name[pos+1]));
        }
        curp->name[strlen(curp->name)-1]=0; 
        fscanf(inputF,"%hd, %hd, %d",&curp->date, &curp->pages, &curp->price);
        // checkeof(inputF);
        // fscanf(inputF,"%hd",&curp->date);
        // checkeof(inputF);
        // fscanf(inputF,"%hd",&curp->pages);
        // checkeof(inputF);
        // fscanf(inputF,"%d",&curp->price);
        *total+=1;
    }
    printf("Read successful.\n");
    return head;
}
char delparam(struct book** phead,const unsigned int n, unsigned int *total){
    if(!*phead)return 0;
    char returnme=0;
    while ((*phead)->price<n){delfirst(phead,total);returnme=1;}
    struct book* pheadclone=*phead;
    while (pheadclone->next)
    {
        if (pheadclone->next->price<n){
            delnext(pheadclone,total);
            returnme=1;
            continue;
        }
        pheadclone=pheadclone->next;
    }
    return returnme;
}

char delparamq(struct book** phead,const unsigned int n, unsigned int *total){
    if(!*phead)return 0;
    char returnme=0;
    struct book newHead;
    struct book *pNewHead=&newHead;
    struct book *pheadclone=*phead;
    struct book *headclone=*phead;
    do{
        if (pheadclone->price<n){
            if(returnme){
                pNewHead->next=malloc(sizeof(struct book));
                pNewHead=pNewHead->next;
            }
            strcpy(pNewHead->name,pheadclone->name);
            strcpy(pNewHead->author,pheadclone->author);
            pNewHead->date=pheadclone->date;
            pNewHead->pages=pheadclone->pages;
            pNewHead->price=pheadclone->price;
            returnme=1;
        }
        pheadclone=pheadclone->next;
    }while (pheadclone&&pheadclone->next);
    printf("WILL BE DELETED:\n");
    displayevery(&newHead);
    do{
        printf("confirm deletion? (y/n): ");
        getchar();
        scanf("%[^\n]%*c",newHead.name);
        if (*newHead.name == 'y'){
            printf("deleted.\n");
            return delparam(phead,n,total);
        }
        else if (*newHead.name == 'n')return 1;
        else {
            printf("Incorrect input.\n");
            continue;
        }
    }while(0);
    return returnme;
}
int isInt(const char *input) {
    int i = 0;
    while (input[i] && input[i]!=10) {
        if (input[i]<48||input[i]>57) return 0;
        i++;
    }
    return 1;
}

void append(struct book *head, unsigned int *total, unsigned short year){
    char userInput[maxlenght];
    //char yn='y';
    //while (yn=='y'){
    struct book* operate;
    if(*total)operate=malloc(sizeof (struct book));
    else operate=head;
    printf("Enter author: ");
    getchar();
    fgets(operate->author,maxlenght,stdin);
    checkoverflow(operate->author);
    printf("Enter book name: ");
    fgets(operate->name,maxlenght,stdin);
    checkoverflow(operate->author);
    operate->author[strlen(operate->author)-1]=0; //вилучення \n
    do{
    operate->name[strlen(operate->name)-1]=0;//Подейкують, що саме тоді шумери почали писати книги
        if(operate->date>year+1||operate->date<-2315){
        printf("Incorrect year.\n");
        continue;
        }
    }while(0);
    operate->date=getnum("Enter book release year: ");
    operate->price=getnum("Enter book pages number: ");
    operate->pages=getnum("Enter book price: ");
    if(*total)gettail(head)->next=operate;
    (*total)++;
    //printf("Input more? (y/n) ");
    //getchar();scanf("%c",&yn);}
}
int getnum(char* out){
    char userInput[5];
    while(1){
        printf("%s",out);
        fgets(userInput,5,stdin);
        checkoverflowl(userInput,5);
        if (isInt(userInput)){
            return atoi(userInput);
        }
        else
            printf("Incorrect input.\n");
    }
}
